<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "device_model".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DeviceModel".
 *
 * Columns in table "device_model" available as properties of the model,
 * followed by relations of table "device_model" available as properties of the model.
 *
 * @property string $id
 * @property string $name
 * @property string $status
 * @property integer $serial_length
 * @property string $serial_starts
 *
 * @property Device[] $devices
 */
abstract class BaseDeviceModel extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'device_model';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DeviceModel|DeviceModels', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('serial_length', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 255),
            array('status', 'length', 'max' => 1),
            array('serial_starts', 'length', 'max' => 10),
            array('status, serial_length, serial_starts', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, status, serial_length, serial_starts', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'devices' => array(self::HAS_MANY, 'Device', 'device_model_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'status' => Yii::t('app', 'Status'),
            'serial_length' => Yii::t('app', 'Serial Length'),
            'serial_starts' => Yii::t('app', 'Serial Starts'),
            'devices' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('serial_length', $this->serial_length);
        $criteria->compare('serial_starts', $this->serial_starts, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
